<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Destination Operands</TITLE>
<link href="suif1_26.html" rel=Next>
<link href="suif1_24.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_24.html">previous</A>, <A HREF="suif1_26.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC25" HREF="suif1_toc.html#TOC25">Destination Operands</A></H3>
<P>
<A NAME="IDX144"></A>
<A NAME="IDX145"></A>

</P>
<P>
<A NAME="IDX146"></A>
The base <CODE>instruction</CODE> class includes a field for the destination
operand, even though not all instructions use it.  The <CODE>dst_op</CODE>
method returns the value of this operand.  If an instruction does not
produce a result, the destination operand should always be a null
operand.  Moreover, the destination may be null even if an instruction
does produce a result.  In that case, the result value is computed and
then discarded.

</P>
<P>
If the destination operand is a variable, its type must be compatible
with the result type of the instruction.

</P>
<P>
If the result of an instruction is a temporary value, the destination
operand is a pointer to the instruction where the value is used.  Note
that this is different than an instruction pointer in a source operand.
The source operands of an instruction point to the children in an
expression tree, while the destination operand points to the parent
instruction.

</P>
<P>
<A NAME="IDX147"></A>
The <CODE>set_dst</CODE> method may be used to set the destination operand for
an instruction.  However, there are some important restrictions on using
this method:

</P>

<UL>
<LI>

For derived classes with instructions that never produce result values,
it is illegal to call <CODE>set_dst</CODE>.  This allows the library to ensure
that the destination will always be a null operand <A NAME="DOCF3" HREF="suif1_foot.html#FOOT3">(3)</A>.
Trying to use <CODE>set_dst</CODE> for one of these instructions will cause an
error.

<LI>

You may not set the destination operand to point to another instruction;
trying to do so will cause an error.  This is to prevent inconsistent
pointers.  The destination should only point to another instruction if
that other instruction has a source operand that points back to it.
Thus, the library automatically sets the destination operand when an
instruction is used as a source operand.

<LI>

If the destination operand already contains a pointer to another
instruction, you cannot use <CODE>set_dst</CODE> to overwrite it.  This also
causes a run-time error.  As in the previous case, this is to prevent
inconsistent pointers.  Instead, you must first call the instruction's
<CODE>remove</CODE> method to clear the destination operand.  See section <A HREF="suif1_28.html#SEC28">Source Operands</A>.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_24.html">previous</A>, <A HREF="suif1_26.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
